• Русский
  • HelmRequest [app.alauda.io/v1]

    Type
    object
    Required
    spec

    Specification

    PropertyTypeDescription
    apiVersionstring

    APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

    kindstring

    Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

    metadataObjectMeta

    ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

    specobject
    statusobject

    .spec

    Type
    object
    PropertyTypeDescription
    chartstring
    clusterNamestring

    ClusterName is the cluster where the chart will be installed. If InstallToAllClusters=true, this field will be ignored

    dependenciesarray

    Dependencies is the dependencies of this HelmRequest, it's a list of there names THe dependencies must lives in the same namespace, and each of them must be in Synced status before we sync this HelmRequest

    installToAllClustersboolean

    InstallToAllClusters will install this chart to all available clusters, even the cluster was created after this chart. If this field is true, ClusterName will be ignored(useless)

    namespacestring

    Namespace is the namespace where the Release object will be lived in. Notes this should be used with the values defined in the chart, otherwise the install will failed

    releaseNamestring

    ReleaseName is the Release name to be generated, default to HelmRequest.Name. If we want to manually install this chart to multi clusters, we may have different HelmRequest name(with cluster prefix or suffix) and same release name

    sourceobject

    Source defines the source of chart, If this field is set, Chart and Version field will be ignored(useless)

    targetClustersobject

    TargetClusters defines the target clusters which the chart will be installed

    valuesobject

    Values represents a collection of chart values.

    valuesFromarray

    ValuesFrom represents values from ConfigMap/Secret...

    versionstring

    .spec.dependencies

    Description
    Dependencies is the dependencies of this HelmRequest, it's a list of there names THe dependencies must lives in the same namespace, and each of them must be in Synced status before we sync this HelmRequest
    Type
    array

    .spec.dependencies[]

    Type
    string

    .spec.source

    Description
    Source defines the source of chart, If this field is set, Chart and Version field will be ignored(useless)
    Type
    object
    PropertyTypeDescription
    httpobject
    ociobject

    .spec.source.http

    Type
    object
    Required
    url
    PropertyTypeDescription
    secretRefstring

    SecretRef A Secret reference, the secret should contain accessKeyId (user name) base64 encoded, and secretKey (password) also base64 encoded

    urlstring

    URL is the URL of the http(s) endpoint

    .spec.source.oci

    Type
    object
    Required
    repo
    PropertyTypeDescription
    repostring

    Repo is the repo of the oci artifact

    secretRefstring

    SecretRef A Secret reference, the secret should contain accessKeyId (user name) base64 encoded, and secretKey (password) also base64 encoded

    .spec.targetClusters

    Description
    TargetClusters defines the target clusters which the chart will be installed
    Type
    object
    PropertyTypeDescription
    clusterLabelsobject

    ClusterLabels store the key value of labels to match clusters

    clusterNamesobject

    ClusterNames store a list of cluster names

    .spec.targetClusters.clusterLabels

    Description
    ClusterLabels store the key value of labels to match clusters
    Type
    object
    Required
    labelSelector
    PropertyTypeDescription
    labelSelectorobject

    .spec.targetClusters.clusterLabels.labelSelector

    Type
    object

    .spec.targetClusters.clusterNames

    Description
    ClusterNames store a list of cluster names
    Type
    object
    Required
    names
    PropertyTypeDescription
    namesarray

    .spec.targetClusters.clusterNames.names

    Type
    array

    .spec.targetClusters.clusterNames.names[]

    Type
    string

    .spec.values

    Description
    Values represents a collection of chart values.
    Type
    object

    .spec.valuesFrom

    Description
    ValuesFrom represents values from ConfigMap/Secret...
    Type
    array

    .spec.valuesFrom[]

    Description
    ValuesFromSource represents a source of values, only one of it's fields may be set
    Type
    object
    PropertyTypeDescription
    configMapKeyRefobject

    ConfigMapKeyRef selects a key of a ConfigMap

    secretKeyRefobject

    SecretKeyRef selects a key of a Secret

    .spec.valuesFrom[].configMapKeyRef

    Description
    ConfigMapKeyRef selects a key of a ConfigMap
    Type
    object
    Required
    key
    PropertyTypeDescription
    keystring

    The key to select.

    namestring

    Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?

    optionalboolean

    Specify whether the ConfigMap or its key must be defined

    .spec.valuesFrom[].secretKeyRef

    Description
    SecretKeyRef selects a key of a Secret
    Type
    object
    Required
    key
    PropertyTypeDescription
    keystring

    The key of the secret to select from. Must be a valid secret key.

    namestring

    Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?

    optionalboolean

    Specify whether the Secret or its key must be defined

    .status

    Type
    object
    PropertyTypeDescription
    conditionsarray
    lastSpecHashstring

    LastSpecHash store the has value of the synced spec, if this value not equal to the current one, means we need to do a update for the chart

    notesstring

    Notes is the contents from helm (after helm install successfully it will be printed to the console

    phasestring

    HelmRequestPhase is a label for the condition of a HelmRequest at the current time.

    reasonstring

    Reason will store the reason why the HelmRequest deploy failed

    syncedClustersarray

    SyncedClusters will store the synced clusters if InstallToAllClusters is true

    targetClusterSyncResultsobject

    TargetClusterSyncResults will store the chart sync result of every target cluster

    versionstring

    Verions is the real version that installed

    .status.conditions

    Type
    array

    .status.conditions[]

    Type
    object
    PropertyTypeDescription
    lastProbeTimestring

    Last time we probed the condition.

    lastTransitionTimestring

    Last time the condition transitioned from one status to another.

    messagestring

    Human-readable message indicating details about last transition.

    reasonstring

    Unique, one-word, CamelCase reason for the condition's last transition.

    statusstring

    Status is the status of the condition. Can be True, False, Unknown. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions

    typestring

    Type is the type of the condition. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions

    .status.syncedClusters

    Description
    SyncedClusters will store the synced clusters if InstallToAllClusters is true
    Type
    array

    .status.syncedClusters[]

    Type
    string

    .status.targetClusterSyncResults

    Description
    TargetClusterSyncResults will store the chart sync result of every target cluster
    Type
    object

    API Endpoints

    The following API endpoints are available:

    • /apis/app.alauda.io/v1/namespaces/{namespace}/helmrequests
      • DELETE: delete collection of HelmRequest
      • GET: list objects of kind HelmRequest
      • POST: create a new HelmRequest
    • /apis/app.alauda.io/v1/namespaces/{namespace}/helmrequests/{name}
      • DELETE: delete the specified HelmRequest
      • GET: read the specified HelmRequest
      • PATCH: partially update the specified HelmRequest
      • PUT: replace the specified HelmRequest
    • /apis/app.alauda.io/v1/namespaces/{namespace}/helmrequests/{name}/status
      • GET: read status of the specified HelmRequest
      • PATCH: partially update status of the specified HelmRequest
      • PUT: replace status of the specified HelmRequest

    /apis/app.alauda.io/v1/namespaces/{namespace}/helmrequests

    HTTP method
    DELETE
    Description
    delete collection of HelmRequest
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    list objects of kind HelmRequest
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequestList schema
    401 - UnauthorizedEmpty
    HTTP method
    POST
    Description
    create a new HelmRequest
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyHelmRequest schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    201 - CreatedHelmRequest schema
    202 - AcceptedHelmRequest schema
    401 - UnauthorizedEmpty

    /apis/app.alauda.io/v1/namespaces/{namespace}/helmrequests/{name}

    HTTP method
    DELETE
    Description
    delete the specified HelmRequest
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    202 - AcceptedStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    read the specified HelmRequest
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update the specified HelmRequest
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace the specified HelmRequest
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyHelmRequest schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    201 - CreatedHelmRequest schema
    401 - UnauthorizedEmpty

    /apis/app.alauda.io/v1/namespaces/{namespace}/helmrequests/{name}/status

    HTTP method
    GET
    Description
    read status of the specified HelmRequest
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update status of the specified HelmRequest
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace status of the specified HelmRequest
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyHelmRequest schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKHelmRequest schema
    201 - CreatedHelmRequest schema
    401 - UnauthorizedEmpty